      program testsig
c
c  generate a test signal. Up to 60 sine waves can be summed
c  and white noise added.
      parameter(ndim=1200000)
      
      real*4 x(ndim)
      character name*10,par*20,text*40,noisfi*10
      character*50 prolog(64)
      character*1 ja
      data par/'                    '/
      text=' Generate a test signal in SEIFE format '
    6 write(6,'(a/" Enter a filename: ")') text
      read(5,'(a)') name
      write(6,'(" How many samples? ")')
      read(5,*) n
      if(n.gt.ndim) stop "n > ndim - stop"
      write(6,'(" Sampling interval [s]? ")')
      read(5,*) dt
      zpi=8.*atan(1.)
      npro=0
      do 4 j=1,n
    4 x(j)=0.
    1 write(6,'(" Period of sinewave [s]? [0=no more]: " )')
      read(5,*) per
      if(per.eq.0.) goto 2
      write(6,'(" Amplitude? ")')
      read(5,*) amp
      write(6,'(" Phase in degrees? ")')
      read(5,*) phi
      npro=npro+1
      write(prolog(npro),5) per,amp,phi
    5 format("%    per=",f10.3," amp=",f10.3," phi=", f10.3)
      phi=phi/360.*zpi
      omega=zpi/per
      do 3 j=1,n
      t=(j-1)*dt
    3 x(j)=x(j)+amp*cos(omega*t+phi)
      if(npro.le.60) goto 1

    2 write(6,'(" Add white noise with amplitude:")')
      read(5,*) amp
      if(amp.gt.0.) then
      do 18 j=1,n
      idum=13
   18 x(j)=x(j)+amp*gasdev(idum)
      npro=npro+1
      write(prolog(npro),9) amp
    9 format("%    white noise, amp=",f10.3)
      endif
    7 write(6,'(" output format? [<cr>=(8f9.3)]: ")')
      read(5,'(a20)') par
      call output(name,prolog,npro,par,text,n,dt,x)
      write(6,'(" Done. Another file? [y/n]")')
      read(5,'(a)') ja
      if(ja.eq.'y') goto 6
      stop
      end

      subroutine output(name,prolog,npro,par,text,n,dt,x)
      real*4 x(n),z(16)
      character name*10,text*40,par*20,iform*20
      character*50 prolog(npro)
      iform='(8f9.3)'
      if(par(1:1).eq.'(') read(par,'(a20)') iform
      write(6,5) name
    5 format(" signal will be stored as file ",a10)
      open(8,file=name)
      write(8,'(a)') text
      do j=1,npro
      write(8,'(a)') prolog(j)
      enddo
      write(8,1) n,iform,dt
    1 format(i10,a20,3f10.3,2i5,a10)
      write(8,iform) (x(j),j=1,n)
      close(8)
      write(*,*) ' done!'
      return
      end
      
      FUNCTION GASDEV(IDUM)
      DATA ISET/0/
      IF (ISET.EQ.0) THEN
1     continue
c      call random_number(V1)
c      call random_number(V2)
        V1=2.*RAN2(IDUM)-1.
        V2=2.*RAN2(IDUM)-1.
        R=V1**2+V2**2
        IF(R.GE.1.)GO TO 1
        FAC=SQRT(-2.*LOG(R)/R)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1
      ELSE
        GASDEV=GSET
        ISET=0
      ENDIF
      RETURN
      END
      
      FUNCTION RAN2(IDUM)
      PARAMETER (M=714025,IA=1366,IC=150889,RM=1.4005112E-6)
      DIMENSION IR(97)
      DATA IFF /0/
      IF(IDUM.LT.0.OR.IFF.EQ.0)THEN
        IFF=1
        IDUM=MOD(IC-IDUM,M)
        DO 11 J=1,97
          IDUM=MOD(IA*IDUM+IC,M)
          IR(J)=IDUM
11      CONTINUE
        IDUM=MOD(IA*IDUM+IC,M)
        IY=IDUM
      ENDIF
      J=1+(97*IY)/M
      IF(J.GT.97.OR.J.LT.1)PAUSE
      IY=IR(J)
      RAN2=IY*RM
      IDUM=MOD(IA*IDUM+IC,M)
      IR(J)=IDUM
      RETURN
      END
